' $Id: asfenable.vbs,v 1.1 2008/11/19 15:35:22 mzimmerm Exp $
'
'*****************************************************************************
'*
'*      LICENSE:
'*      (C)Copyright 2008 Marvell.
'*      All Rights Reserved
'*
'*      THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF MARVELL
'*      The copyright notice above does not evidence any
'*      actual or intended publication of such source code.
'*
'*      This Module contains Proprietary Information of Marvell
'*      and should be treated as Confidential.
'*
'*      The information in this file is provided for the exclusive use of
'*      the licensees of Marvell. Such users have the right to use, modify, 
'*      and incorporate this code into products for purposes authorized by
'*      the license agreement provided they include this notice and the 
'*      associated copyright notice with any such product.
'*
'*      The information in this file is provided "AS IS" without warranty.
'*      /LICENSE
'*
'*****************************************************************************/
 
' This script connects to a local or remote WMI provider
' and configures a subset of ASF related properties.
'
' For local connections no user credentials must be provided.
' Local connections use the current user (WMI restriction).
'
' Following are the requirements on the remote system:
' - specified user belongs to administrator group
' - password is set for the specified user
' - open firewall for WMI access
' - configure "Network access: Sharing and security model for local accounts" to
'   setting "Classic - local users authenticate themselves"
'   (Control Panel -> Administrative Tools -> Local Security Policy -> Local Policies -> Security Option)
' - on Vista use a domain account (which is in the domain administrators group) or disable UAC


Option Explicit

sub usage()
	wscript.echo "Usage:", _
		vbCrLf, "   Local access:", _
		vbCrLf, "      cscript", _
		wscript.scriptname, _ 
		" {enable|disable}", _
		vbCrLf, "      cscript", _
		wscript.scriptname, _ 
		" trap <ip-address>", _
		vbCrLf, "      cscript", _
		wscript.scriptname, _ 
		" heartbeat {enable|disable|<seconds>}", _
		vbCrLf, "   Remote access:", _
		vbCrLf, "      cscript", _
		wscript.scriptname, _ 
		" {enable|disable}  <username> <password> <server1> <server2> <server3> ...", _
		vbCrLf, "      cscript", _
		wscript.scriptname, _ 
		" trap <ip-address>  <username> <password> <server1> <server2> <server3> ...", _
		vbCrLf, "      cscript", _
		wscript.scriptname, _ 
		" heartbeat {enable|disable|<seconds>}  <username> <password> <server1> <server2> <server3> ...", _
		vbCrLf
	Wscript.quit 2
end sub

Dim args
DIM objLocator, objNamespace, asf, ddd
dim what, server, username, password, argument, serverlist
dim inst, c

Set args = wscript.arguments
'wscript.echo "count=", args.count
if args.count < 1 then
	usage
end if
what		= args(0)
'wscript.echo "what=", what

argument		= ""
username	= ""
if what = "enable" or what = "disable" then
	if args.count >= 4 then
		username	= args(1)
		password	= args(2)
		serverlist	= 3
	elseif args.count >1 and args.count < 4 then
		usage
	end if
elseif what = "trap" then
	if args.count < 2 then
		usage
	end if
	argument	= args(1)
	if args.count >= 5 then
		username	= args(2)
		password	= args(3)
		serverlist	= 4
	elseif args.count >2 and args.count < 5 then
		usage
	end if
elseif what = "heartbeat" then
	if args.count < 2 then
		usage()
	end if
	argument	= args(1)
	if args.count >= 5 then
		username	= args(2)
		password	= args(3)
		serverlist	= 4
	elseif args.count >2 and args.count < 5 then
		usage
	end if
else
	usage
end if


Set objLocator = Createobject("WbemScripting.SWbemLocator")

if username = "" then
	wscript.echo "Accessing 'root\CIMV2'-namespace on local machine."
	call handle_host(what, argument, "", "", "")
else
	for c=serverlist to args.count - 1
		server	= args(c)
		wscript.echo vbCrLf & "Accessing 'root\CIMV2'-namespace on machine ", server
		call handle_host(what, argument, server, username, password)
	next
end if

sub handle_host(what, argument, server, username, password)
	'wscript.echo "arglist:", what, argument, server, username, password

	if server = "" then
		Set objNamespace = objLocator.ConnectServer(, "root\CIMV2")
	else
		Set objNamespace = objLocator.ConnectServer(server, "root\CIMV2", username, password)
	end if

	'objNamespace.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate
	objNamespace.Security_.ImpersonationLevel = 3
	'objNamespace.Security_.AuthenticationLevel = wbemAuthenticationLevelPktPrivacy
	objNamespace.Security_.AuthenticationLevel = 6

	Set asf = objNamespace.execquery("select * from YukonNet_ASF_OOBAlertService")


	' if class or instances of the class do not exist
	' access to the object will result in a runtime error.
	' the following construct will suppress such an error.
	on error resume next
	inst = 0
	inst = asf.count
	on error goto 0
	wscript.echo "Found", inst, "instance(s)."
	if inst = 0 then
		wscript.echo "No instance found. Skipping."
		exit sub
	end if

	for each ddd in asf
		if what = "enable" or what = "disable" then
			if ddd.AsfEnable = TRUE then
				if what = "enable" then
					wscript.echo "ASF is already enabled. Nothing to do."
					exit sub
				end if
				Wscript.Echo "Disabling ASF."
				ddd.AsfEnable = FALSE
			else
				if what = "disable" then
					wscript.echo "ASF is already disabled. Nothing to do."
					exit sub
				end if
				Wscript.Echo "Enabling ASF."
				ddd.AsfEnable = TRUE
			end if
			ddd.Put_
			exit for
		end if
		if what = "trap" then
			Wscript.Echo "Setting trap destination IP address."
			ddd.DestinationAddress = argument
			ddd.Put_
			exit for
		end if 
		if what = "heartbeat" then
			if argument = "enable" then
				Wscript.Echo "Enabling heartbeat timer."
				ddd.EnablePresenceHeartbeats = TRUE
			elseif argument = "disable" then
				Wscript.Echo "Disabling heartbeat timer."
				ddd.EnablePresenceHeartbeats = FALSE
			else
				Wscript.Echo "Setting heartbeat timer value to", argument
				ddd.PresenceHeartbeatInterval = argument
			end if
			ddd.Put_
			exit for
		end if 
	next
end sub


