' $Id: dashenable.vbs,v 1.2 2008/10/23 09:10:34 mzimmerm Exp $
'
' This script connects to a local or remote WMI provider
' and enables or disables DASH.
'
' For local connections no user credentials must be provided.
' Local connections use the current user (WMI restriction).
'
' Following are the requirements on the remote system:
' - specified user belongs to administrator group
' - password is set for the specified user
' - open firewall for WMI access
' - configure "Network access: Sharing and security model for local accounts" to
'   setting "Classic - local users authenticate themselves"
'   (Control Panel -> Administrative Tools -> Local Security Policy -> Local Policies -> Security Option)
' - on Vista use a domain account (which is in the domain administrators group) or disable UAC


Option Explicit

sub usage()
	wscript.echo "Usage:", _
		vbCrLf, " cscript", _
		wscript.scriptname, _ 
		"{enable|disable}", _
		vbCrLf, " cscript", _
		wscript.scriptname, _ 
		"{enable|disable} <username> <password> <server1> <server2> <server3> ...", _
		vbCrLf 
	Wscript.quit 2
end sub

Dim args
DIM objLocator, objNamespace, dash, ddd
dim what, server, username, password
dim inst, c

Set args = wscript.arguments
'wscript.echo "count=", args.count
if args.count <> 1 and args.count < 4 then
	usage
end if

what		= args(0)
'wscript.echo "what=", what
if what <> "enable" and what <> "disable" then
	usage
end if

if args.count >= 4 then
	username	= args(1)
	password	= args(2)
end if


Set objLocator = Createobject("WbemScripting.SWbemLocator")

if args.count = 1 then
	wscript.echo "Accessing 'root\CIMV2'-namespace on local machine."
	call handle_host(what, "", "", "")
else
	for c=3 to args.count - 1
		server	= args(c)
		wscript.echo vbCrLf & "Accessing 'root\CIMV2'-namespace on machine ", server
		call handle_host(what, server, username, password)
	next
end if

sub handle_host(what, server, username, password)
	'wscript.echo "arglist:", what, server, username, password

	if server = "" then
		Set objNamespace = objLocator.ConnectServer(, "root\CIMV2")
	else
		Set objNamespace = objLocator.ConnectServer(server, "root\CIMV2", username, password)
	end if

	'objNamespace.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate
	objNamespace.Security_.ImpersonationLevel = 3
	'objNamespace.Security_.AuthenticationLevel = wbemAuthenticationLevelPktPrivacy
	objNamespace.Security_.AuthenticationLevel = 6

	'Set dash = objNamespace.instancesof("YukonNet_Dash")
	Set dash = objNamespace.execquery("select * from YukonNet_Dash")

	'wscript.echo "type dash is =", vartype(dash)

	' if class or instances of the class do not exist
	' access to the object (dash) will result in a runtime error.
	' the following construct will suppress such an error.
	on error resume next
	inst = 0
	inst = dash.count
	on error goto 0
	wscript.echo "Found", inst, "instance(s)."
	if inst = 0 then
		wscript.echo "No instance found. Skipping."
		exit sub
	end if

	for each ddd in dash

		'Wscript.Echo "DashEnable=" & ddd.DashEnable 

		if ddd.DashEnable = True then
			if what = "enable" then
				wscript.echo "DASH is already enabled. Nothing to do."
				exit sub
			end if
			Wscript.Echo "Disabling DASH."
			ddd.DashEnable = FALSE
		else
			if what = "disable" then
				wscript.echo "DASH is already disabled. Nothing to do."
				exit sub
			end if
			Wscript.Echo "Enabling DASH."
			ddd.DashEnable = TRUE

		end if
		ddd.Put_

		exit for
	next
end sub

